<?php

/**
 * All Rights Reserved.
 * Modification, redistribution and use in source and binary forms, with or without
 * modification are permitted but WITHOUT ANY WARRANTY; under the terms of the GNU General Public License.
 *
 * Vendor: EXTREME IDEA LLC http://www.extreme-idea.com
 */

use com\extremeidea\bidorbuy\storeintegrator\core as bobsi;

require('includes/application_top.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');
require_once(dirname(__FILE__) . '/../includes/modules/bidorbuystoreintegrator/factory.php');

$action = (isset($_POST['action'])) ? $_POST['action'] : false;

/***************** ADMIN FORM ACTIONS ****************/

// Reset Tokens action
if (isset($_POST[bobsi\Settings::NAME_ACTION_RESET]) && $action === 'reset_tokens') {
    bobsi\StaticHolder::getBidorbuyStoreIntegrator()->processAction(bobsi\Settings::NAME_ACTION_RESET);

    //Write into DB
    zen_db_perform(TABLE_CONFIGURATION, array(
        'configuration_value' => bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->serialize(true),
        'last_modified' => 'now()'
    ), 'update', ' configuration_key = "' . strtoupper(bobsi\Settings::NAME) . '"');

    $messageStack->add('Success: The tokens updated.', 'success');
}

// Save settings to DB
if (!empty($_POST) && empty($_POST[bobsi\Settings::NAME_LOGGING_FORM_ACTION]) && $action === 'save') {
    $validSetting = bobsi\Settings::validateNameFileName($_POST['filename']);
    $message = $validSetting ? 'Settings successfully saved!'
        : 'Warning: Incorrect Export Filename. <br> 16 characters max. Must start with a letter. '
        . 'Can contain letters, digits, `-` and `_`';
    $status = $validSetting ? 'success' : 'error';
    if ($validSetting) {
        bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->unserialize(serialize($_POST));
        //Write into DB
        zen_db_perform(TABLE_CONFIGURATION, array(
            'configuration_value' => bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->serialize(true),
            'last_modified' => 'now()'
        ), 'update', ' configuration_key = "' . strtoupper(bobsi\Settings::NAME) . '"');
    }
    $messageStack->add($message, $status);
}

//Log files actions: Download, Remove
if (isset($_POST[bobsi\Settings::NAME_LOGGING_FORM_ACTION])) {
    $data = array(
        bobsi\Settings::NAME_LOGGING_FORM_FILENAME => (isset($_POST[bobsi\Settings::NAME_LOGGING_FORM_FILENAME]))
            ? $_POST[bobsi\Settings::NAME_LOGGING_FORM_FILENAME] : ''
    );
    $result = bobsi\StaticHolder::getBidorbuyStoreIntegrator()
        ->processAction($_POST[bobsi\Settings::NAME_LOGGING_FORM_ACTION], $data);
    foreach ($result as $item) {
        $messageStack->add($item, 'success');
    }
}

$settings = (array)bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings();
$settings = array_shift($settings);
$wordings = bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getDefaultWordings();

$assetsPath = '../includes/modules/bidorbuystoreintegrator/vendor/com.extremeidea.bidorbuy/'
    . 'storeintegrator-core/assets';

$export_categories = bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getExcludeCategories();
$cats = zen_get_category_tree('0', '', '0');

$baa = isset($_REQUEST['baa']) ? $_REQUEST['baa'] : false;

/* feature 3909 */
$warnings = array_merge(
    bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getWarnings(),
    bobsi\StaticHolder::getWarnings()->getBusinessWarnings()
);

foreach ($warnings as $warning) {
    $messageStack->add($warning, 'error');
}
/* */
?>

    <!--***************** ADMIN VIEW ****************-->

    <!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
    <html <?php echo HTML_PARAMS; ?>>
    <head>
        <!--Fix IE defect ui -->
        <meta http-equiv="X-UA-Compatible" content="IE=8">
        <!-- End Fix -->
        <meta http-equiv="X-UA-Compatible" content="IE=8">
        <meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
        <title><?php echo TITLE; ?></title>
        <link rel="stylesheet" type="text/css" href="includes/modules/bidorbuystoreintegrator/assets/css/styles.css">
        <link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
        <link rel="stylesheet" type="text/css" href="includes/cssjsmenuhover.css" media="all" id="hoverJS">
        <script language="javascript" src="includes/menu.js"></script>
        <script language="javascript" src="includes/general.js"></script>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
        <script language="javascript"
                src="<?php echo $assetsPath?>/js/admin.js"></script>
        <script language="javascript" src="includes/modules/bidorbuystoreintegrator/assets/js/admin_aux.js"></script>
        <script type="text/javascript">

            function init() {
                cssjsmenu('navbar');
                if (document.getElementById) {
                    var kill = document.getElementById('hoverJS');
                    kill.disabled = true;
                }
            }

        </script>
    </head>
    <body onLoad="init()" class="zencart">
    <?php require(DIR_WS_INCLUDES . 'header.php'); ?>


    <div id="bobsi-admin-header">
        <div id="bobsi-icon-trade-feed" style="background-image: url('images/bidorbuystoreintegrator/bidorbuy.png');">

        </div>
        <h1><?php echo bobsi\Version::$name; ?></h1>

        <div id="bobsi-adv">
            <!-- BEGIN ADVERTPRO CODE BLOCK -->
            <script type="text/javascript">
                document.write('<scr' +
                    'ipt src="https://nope.bidorbuy.co.za/servlet/view/banner/javascript/zone?zid=153&pid=0&random=' +
                    Math.floor(89999999 * Math.random() + 10000000) + '&millis=' + new Date().getTime() +
                    '&referrer=' + encodeURIComponent(document.location) + '" type="text/javascript"></scr' +
                    'ipt>');
            </script>
            <!-- END ADVERTPRO CODE BLOCK -->
        </div>
    </div>


    <?php echo zen_draw_form('export', FILENAME_BOBSI_ADM, '', 'post', 'enctype="multipart/form-data" id="form"')
        . zen_hide_session_id() . zen_draw_hidden_field('action', 'save'); ?>

    <fieldset>
        <!-- EXPORT CONFIGURATION TABLE  -->
        <div class="postbox-item postbox-left">
            <table class="<?php echo bobsi\Settings::NAME_EXPORT_CONFIGURATION; ?>" cellspacing="0"
                   cellpadding="0">
                <tr>
                    <td class="formAreaTitle">
                        <h4 class="subheader"><?php echo $wordings[bobsi\Settings::NAME_EXPORT_CONFIGURATION]
                            [bobsi\Settings::NAME_WORDINGS_TITLE]; ?></h4>
                    </td>
                </tr>
                <tr>
                    <td>
                        <table border="0" cellpadding="2" cellspacing="0" class="inner-box">
                            <tbody>
                            <!-- FILENAME -->
                            <tr>
                                <?php $name = bobsi\Settings::NAME_FILENAME; ?>
                                <td class="main mainLabel hastip">
                                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                                </td>
                                <td class="main">
                                    <?php echo zen_draw_input_field($name, $settings[$name]); ?>
                                    <p class="tip"> <?php echo $wordings[$name]
                                        [bobsi\Settings::NAME_WORDINGS_DESCRIPTION]; ?></p>
                                </td>
                            </tr>

                            <!-- COMPRESS LIBRARY -->
                            <tr>
                                <?php $name = bobsi\Settings::NAME_COMPRESS_LIBRARY; ?>
                                <td class="main mainLabel hastip">
                                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                                </td>
                                <td class="main">
                                    <select name="<?php echo $name; ?>" id="<?php echo $name; ?>">
                                        <?php $libs = bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()
                                            ->getCompressLibraryOptions();

                                        $options = '';
                                        foreach ($libs as $lib => $info) {
                                            $options .= '<option value="' . $lib . '" ';
                                            if (bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()
                                                    ->getCompressLibrary() == $lib) {
                                                $options .= ' selected="selected"';
                                            }
                                            $options .= '>' . ucfirst($lib) . '</option>';
                                        }
                                        echo $options;
                                        ?>
                                    </select>

                                    <p class="tip"> <?php echo $wordings[$name]
                                        [bobsi\Settings::NAME_WORDINGS_DESCRIPTION]; ?></p>
                                </td>
                            </tr>

                            <!-- MIN QUANTITY -->
                            <tr>
                                <?php $name = bobsi\Settings::NAME_DEFAULT_STOCK_QUANTITY; ?>
                                <td class="main mainLabel hastip">
                                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                                </td>
                                <td class="main">
                                    <?php echo zen_draw_input_field($name, $settings[$name], '', false, 'number'); ?>
                                    <p class="tip">
                                        <?php
                                            echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_DESCRIPTION];
                                        ?>
                                    </p>
                                </td>
                            </tr>


                            </tbody>
                        </table>
                    </td>
                </tr>
            </table>
        </div>
        <!-- EXPORT CRITERIA TABLE  -->
        <div class="postbox-item postbox-right">
            <table class="<?php echo bobsi\Settings::NAME_EXPORT_CRITERIA; ?>" cellpadding="0"
                   cellspacing="0">
                <tr>
                    <td class="formAreaTitle">
                        <h4 class="subheader"><?php echo $wordings[bobsi\Settings::NAME_EXPORT_CRITERIA]
                            [bobsi\Settings::NAME_WORDINGS_TITLE]; ?></h4>
                    </td>
                </tr>
                <tr>
                    <td>
                        <table border="0" cellpadding="2" cellspacing="2">
                            <tbody>
                            <!--EXPORT PRODUCTS WITH QUANTITY MORE THAN -->
                            <tr>
                                <?php $name = bobsi\Settings::NAME_EXPORT_QUANTITY_MORE_THAN; ?>
                                <td class="main mainLabel" colspan="2">
                                    <table border="0" cellpadding="0" cellspacing="0" class="inner-box">
                                        <tr>
                                            <td class="hastip">
                                                <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                                            </td>
                                            <td>
                                                <?php
                                                echo zen_draw_input_field(
                                                    $name,
                                                    (string)$settings[$name],
                                                    '',
                                                    false,
                                                    'number'
                                                );
                                                ?>
                                                <p class="tip">
                                                    <?php
                                                    echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_DESCRIPTION];
                                                    ?>
                                                </p>
                                            </td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>

                            <!-- INCLUDE/EXCLUDE CATS -->
                            <tr>
                                <?php $name = bobsi\Settings::NAME_EXCLUDE_CATEGORIES; ?>
                                <td>
                                    <?php
                                    $included_categories = '<select id="bobsi-inc-categories" 
                                                                    class="bobsi-categories-select" 
                                                                    name="bobsi_inc_categories[]" multiple="multiple" 
                                                                    size="9">';
                                    $excluded_categories = "<select id='bobsi-exc-categories' 
                                                                    class='bobsi-categories-select' name='{$name}[]' 
                                                                    multiple='multiple' size='9'>";
                                    foreach ($cats as $category) {
                                        $t = "<option  value='{$category['id']}'>{$category['text']} </option>";
                                        if (in_array($category['id'], $export_categories)) {
                                            $excluded_categories .= $t;
                                            continue;
                                        }
                                        $included_categories .= $t;
                                    }
                                    $included_categories .= '</select>';
                                    $excluded_categories .= '</select>';
                                    $html = '';
                                    $html .= '<table cellspacing="4" cellpadding="2" width=100%>
                                                <tr>
                                                    <td>
                                                        <label for="bobsi-inc-categories">Included Categories</label>
                                                    </td>
                                                    <td></td>
                                                    <td>
                                                    <label for="bobsi-exc-categories">Excluded Categories</label>
                                                    </td>
                                                </tr>';
                                    $html .= '<tr><td>' . $included_categories . '</td>';
                                    $html .= '<td class="buttons-item">
                                                    <p class="submit">
                                                        <button name="include" id="include" 
                                                        class="button" type="button">
                                                            < Include
                                                        </button>
                                                    </p>
                                                    <p class="submit">
                                                        <button name="exclude" 
                                                                id="exclude" class="button" type="button">
                                                            > Exclude
                                                        </button>
                                                    </p>
                                                </td>';
                                    $html .= '<td>' . $excluded_categories . '</td></tr></table>';
                                    echo $html;
                                    ?>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </td>
                </tr>
            </table>
        </div>
        <?php
        echo zen_draw_hidden_field(
            bobsi\Settings::NAME_TOKEN_DOWNLOAD,
            bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getTokenDownload()
        );
        ?>
        <?php echo zen_draw_hidden_field(
            bobsi\Settings::NAME_TOKEN_EXPORT,
            bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getTokenExport()
        );
        ?>

        <!--SAVE BUTTON-->
        <div class="item-button">
            <?php
                echo zen_draw_input_field('save', 'Save', ' id="submit" ', false, 'submit');
            ?>
        </div>
    </fieldset>
    <!-- DEBUG-->
    <div class="postbox logfiles postbox-item postbox-long">
        <h4 class="subheader">Debug</h4>

        <?php if ($baa == 1) : ?>
        <div class="inner-box">
            <h4><span>Basic Access Authentication</span></h4>
            <span>(if necessary)</span>
            <h4>
                <span style="color: red">
                    Do not enter username or password of ecommerce platform, please read carefully about
                    this kind of authentication!
                </span>
            </h4>
        </div>
        <table class="inner-box">
            <!-- USERNAME -->
            <tr>
                <?php $name = bobsi\Settings::NAME_USERNAME; ?>
                <td class="main mainLabel hastip">
                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                </td>
                <td class="main">
                    <?php echo zen_draw_input_field($name, $settings[$name]); ?>
                    <p class="tip"> <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_DESCRIPTION]; ?></p>
                </td>
            </tr>

            <!-- PASSWORD -->
            <tr>
                <?php $name = bobsi\Settings::NAME_PASSWORD; ?>
                <td class="main mainLabel hastip">
                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                </td>
                <td class="main">
                    <?php echo zen_draw_password_field($name, $settings[$name]); ?>
                    <p class="tip"> <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_DESCRIPTION]; ?></p>
                </td>
            </tr>

            <?php
        else :
            ?>

                <input type="hidden" name="<?= bobsi\Settings::NAME_USERNAME ?>"
                       value="<?= $settings[bobsi\Settings::NAME_USERNAME] ?>"/>
                <input type="hidden" name="<?= bobsi\Settings::NAME_PASSWORD ?>"
                       value="<?= $settings[bobsi\Settings::NAME_PASSWORD] ?>"/>

            <?php
        endif;
            ?>
        </table>
        <table class="inner-box">
            <tr>
                <?php $name = bobsi\Settings::NAME_LOGGING_APPLICATION; ?>
                <td class="main mainLabel hastip">
                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                </td>
                <td class="main">
                    <select name="<?php echo $name; ?>" id="<?php echo $name; ?>">
                        <?php $levels =
                            bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()
                                ->getLoggingApplicationOptions();

                        $options = '';
                        foreach ($levels as $level) {
                            $options .= '<option value="' . $level . '" ';
                            if (bobsi\StaticHolder::getBidorbuyStoreIntegrator()
                                    ->getSettings()->getLoggingApplication() == $level) {
                                $options .= ' selected="selected"';
                            }
                            $options .= '>' . ucfirst($level) . '</option>';
                        }
                        echo $options;
                        ?>
                    </select>

                    <p class="tip"> <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_DESCRIPTION]; ?></p>
                </td>
            </tr>
            <!-- LOGGING LEVEL -->
            <tr>
                <?php $name = bobsi\Settings::NAME_LOGGING_LEVEL; ?>
                <td class="main mainLabel hastip">
                    <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                </td>
                <td class="main">
                    <select name="<?php echo $name; ?>" id="<?php echo $name; ?>">
                        <?php $levels =
                            bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getLoggingLevelOptions();

                        $options = '';
                        foreach ($levels as $level) {
                            $options .= '<option value="' . $level . '" ';
                            if (bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getLoggingLevel()
                                == $level) {
                                $options .= ' selected="selected"';
                            }
                            $options .= '>' . ucfirst($level) . '</option>';
                        }
                        echo $options;
                        ?>
                    </select>

                    <p class="tip"> <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_DESCRIPTION]; ?></p>
                </td>
            </tr>
        </table>
        <fieldset>
            <div class="item-button">
                <input type="button" name="save2" value="Save" onclick="jQuery('#submit').click()">
            </div>
        </fieldset>
        <!--END FORM -->
        </form>

    </div>

    <!--LOGS-->
    <div class="postbox postbox-item postbox-long">
        <h4 class="subheader">Logs</h4>
        <fieldset>
            <?php echo bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getLogsHtml(); ?>
        </fieldset>
    </div>


    <!--LINKS-->
    <?php
        echo zen_draw_form(
            'bobsi-export-links',
            FILENAME_BOBSI_ADM,
            '',
            'post',
            ' id="bobsi-export-links" enctype="multipart/form-data"'
        )
        . zen_hide_session_id()
        . zen_draw_hidden_field('action', 'reset_tokens');
    ?>

    <div class="postbox links postbox-item postbox-long">
        <input class="bobsi-input" type="hidden"
               id="<?php echo bobsi\Settings::NAME_ACTION_RESET; ?>"
               name="<?php echo bobsi\Settings::NAME_ACTION_RESET; ?>"
               value="1"/>

        <h4 class="subheader"><?php echo $wordings[bobsi\Settings::NAME_EXPORT_LINKS]
            [bobsi\Settings::NAME_WORDINGS_TITLE]; ?></h4>

        <fieldset>
            <?php $link_tooltip = 'Click to select';
            $base = (ENABLE_SSL_CATALOG != 'false' && ENABLE_SSL_CATALOG != false) ? HTTPS_CATALOG_SERVER
                . DIR_WS_HTTPS_CATALOG : HTTP_CATALOG_SERVER . DIR_WS_CATALOG;

            $export_link = $base . 'bidorbuystoreintegrator.php?action=export&' . bobsi\Settings::PARAM_TOKEN . '='
                . bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getTokenExport();
            $download_link = $base . 'bidorbuystoreintegrator.php?action=download&' . bobsi\Settings::PARAM_TOKEN . '='
                . bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getTokenDownload();
            $phpInfo_link = $base . 'bidorbuystoreintegrator.php?action=version&' . bobsi\Settings::PARAM_TOKEN . '='
                . bobsi\StaticHolder::getBidorbuyStoreIntegrator()->getSettings()->getTokenDownload() . '&phpinfo=y';
            ?>
            <table id="module" class="form-table export-links">
                <tbody>
                <!-- EXPORT LINK -->
                <tr>

                    <?php $name = bobsi\Settings::NAME_EXPORT_URL; ?>
                    <td class="main mainLabel">
                        <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                    </td>
                    <td class="main hastip">
                        <?php
                        echo zen_draw_input_field(
                            $name,
                            $export_link,
                            ' class="bobsi-url" readonly id="' . bobsi\Settings::NAME_TOKEN_EXPORT . '"'
                        );
                        ?>
                    </td>
                    <td class="narrow button-section right">
                        <p class="tip">
                            <?php echo $link_tooltip; ?>
                        </p>
                        <?php
                        echo zen_draw_input_field(
                            'export_button',
                            'Launch',
                            ' class="button" onclick="window.open(\'' . $export_link . '\',\'_blank\');"',
                            false,
                            'button'
                        );
                        ?>
                        <?php
                        echo zen_draw_input_field('copy', 'Copy', ' class="button copy-button" ', false, 'button');
                        ?>
                    </td>
                </tr>

                <!-- DOWNLOAD LINK -->
                <tr>

                    <?php $name = bobsi\Settings::NAME_DOWNLOAD_URL; ?>
                    <td class="main mainLabel">
                        <?php echo $wordings[$name][bobsi\Settings::NAME_WORDINGS_TITLE]; ?>
                    </td>
                    <td class="main hastip">
                        <?php
                        echo zen_draw_input_field(
                            $name,
                            $download_link,
                            ' class="bobsi-url" readonly id="' . bobsi\Settings::NAME_TOKEN_DOWNLOAD . '"'
                        );
                        ?>
                    </td>
                    <td class="narrow button-section right">
                        <p class="tip">
                            <?php echo $link_tooltip; ?>
                        </p>
                        <?php
                        echo zen_draw_input_field(
                            'export_button',
                            'Launch',
                            ' class="button" onclick="window.open(\'' . $download_link . '\',\'_blank\');"',
                            false,
                            'button'
                        );
                        ?>
                        <?php
                        echo zen_draw_input_field('copy', 'Copy', ' class="button copy-button" ', false, 'button');
                        ?>
                    </td>
                </tr>

                <tr>
                    <td colspan="3" class="right-text">
                        <?php
                        echo zen_draw_input_field(
                            'reset_tokens',
                            $wordings[bobsi\Settings::NAME_BUTTON_RESET][bobsi\Settings::NAME_WORDINGS_TITLE],
                            ' class="button" ',
                            false,
                            'submit'
                        );
                        ?>
                    </td>
                </tr>
                </tbody>
            </table>
        </fieldset>
    </div>
    </form>

    <div class="postbox postbox-item postbox-long">
        <h4 class="subheader">Version</h4>
        <div class="inner-box">
            <a href="<?php echo $phpInfo_link ?>" target="_blank">@See PHP information</a><br>
            <?php echo bobsi\Version::getLivePluginVersion(); ?>
        </div>
    </div>

    <?php require(DIR_WS_INCLUDES . 'footer.php'); ?>

    </body>
    </html>
